import sympy as sp
dict_rhythms = {
  "E(2,3)" : "A common Afro-Cuban drum pattern when started on the second onset as in [101]. For example, it is the conga rhythm of the (6/8)-time Swing Tumbao. It is common in Latin American music, as for example in the Cueca, and the coros de clave. It is common in Arabic music, as for example in the Al Taer rhythm of Nubia. It is also a rhythmic pattern of the Drum Dance of the Slavey Indians of Northern Canada",
  "E(2,5)" : "A rhythm found in Greece, Namibia, Rwanda and Central Africa. It is also a 13th century Persian rhythm called Khafif-e-ramal, as well as the rhythm of the dance Makedonka from the FYROM. Tchaikovsky used it as the metric pattern in the second movement of his Symphony No. 6. Started on the second onset as in [10010] it is a rhythm found in Central Africa, Bulgaria, Turkey, Turkestan and Norway. It is also the metric pattern of Dave Brubeck's Take Five, as well as Mars from The Planets by Gustav Holst. Rotated as in [10010100100], it is a Serbian rhythmic pattern. When it is started on the fourth (last) onset it is the Daasa al kbiri rhythmic pattern of Yemen.",
  "E(3,4)" : "It is the archetypal pattern of the Cumbia from Colombia, as well as a Calypso rhythm from Trinidad. It is also a thirteenth century Persian rhythm called Khalif-e-saghil, as well as the trochoid choreic rhythmic pattern of ancient Greece.",
  "E(3,5)" : "When started on the second onset, it is a thirteenth century Persian rhythm by the name of Khafif-e-ramal, as well as a Rumanian folk-dance rhythm.",
  "E(3,7)" : "It is the Ruchenitza rhythm used in a Bulgarian folk-dance. It is also the metric pattern of Pink Floyd's Money.",
  "E(3,8)" : "It is none other than one of the most famous rythms on the planet. In Cuba it goes by the name of the tresillo and in the USA is often called the Habanera rhythm used in hundreds of rockabilly songs during the 1950s. It can often be heard in early rock-and-roll hits in the left-hand patterns of the piano, or played on the string bass or saxophone. A good example is the bass rhythm in Elvis Presley's Hound Dog. The tresillo pattern is also found widely in West African traditional music. For example, it is played on the atoke bell in the Sohu, an Ewe dance from Ghana. The tresillo can also be recognized as the first bar of the ubiquitous two-bar clave Son given by [1001001000101000].",
  "E(4,7)" : "It is a Ruchenitza Bulgarian folk-dance rhythm.",
  "E(4,9)" : "It is the Aksak rhythm of Turkey. It is also the metric pattern used by Dave Brubeck in his piece Rondo a la Turk.",
  "E(4,11)" : "It is the metric pattern used by Frank Zappa in his piece titled Outside Now.",
  "E(4,12)" : "It is periodic with four repetitions of E(1,3) = [100]. It is the (12/8)-time Fandago clapping pattern in the Flamenco music of southern Spain, where 1 denotes a loud clap and 0 soft clap.",
  "E(4,15)" : "It is the metric pattern of the pancam savari tal of North Indian music.",
  "E(5,6)" : "It yields the York-Samai pattern, a popular Arabic rhythm. It is also a handclapping rhythm used in the Al Medemi songs of Oman.",
  "E(5,7)" : "It is the Nawakhat pattern, a popular Arabic rhythm. In Nubia it is called the Al Noht rhythm.",
  "E(5,8)" : "It is the Cuban cinquillo pattern, the Malfuf rhythmic pattern of Egypt, as well as the Korean Nong Pyon drum pattern. Started on the second onset, it is a popular Middle Eastern rhythm, as well as the Timini rhythm of Senegal, the Adzogbo dance rhythm of Benin, the Spanish Tango, the Maksum of Egypt, and a 13th century Persian rhythm, the Al-saghil-alsani. When it is started on the third onset it is the Musemmen rhythm of Turkey. When it is started on the fourth onset it is the Kromanti rhythm of Surinam.",
  "E(5,9)" : "It is a popular Arabic rhythm called Agsag-Samai. Started on the second onset, it is a drum pattern used by the Venda in South Africa, as well as a Rumanian folk-dance rhythm. It is also the rhythmic pattern of the Sigaktistos rhythm of Greece, and the Samai aktsak rhythm of Turkey. Started on the third onset, it is the rhythmic pattern of the Nawahiid rhythm of Turkey.",
  "E(5,11)" : "It is the metric pattern of the Savari tala used in the Hindustani music of India. It is also a rhythmic pattern used in Bulgaria and Serbia. In Bulgaria is is used in the Kopanitsa. This metric pattern has been used by Moussorgsky in Pictures at an Exhibition. Started on the third onset, it is the rhythm of the dance Kalajdzijsko Oro from the FYROM, and it appears in Bulgarian music as well.",
  "E(5,12)" : "It is a common rhythm played in the Central African Republic by the Aka Pygmies. It is also the Venda clapping pattern of a South African children's song, and a rhythm pattern used in the FYROM. Started on the second onset, it is the Columbia bell pattern popular in Cuba and West Africa, as well as a drumming pattern used in the Chakacha dance of Kenya, and also used in the FYROM . Started on the third onset, it is the Bemba bell pattern used in Northern Zimbabwe, and the rhythm of the dance from the FYROM Ibraim Odza Oro. Started on the fourth onset, it is the Fume Fume bell pattern popular in West Africa, and is a rhythm used in the former Yugoslavia. Finally, when started on the fifth onset it is the Salve bell pattern used in the Dominican Republic in a rhythm called Canto de Vela in honor of the Virgin Mary, as well as the drum rhythmic pattern of the Moroccan Al Kudam.",
  "E(5,13)" : "It is a rhythm from the FYROM which is also played by starting it on the fourth onset as follows: [1010010010100].",
  "E(5,16)" : "It is the Bossa-Nova rhythm necklace of Brazil. The actual Bossa-Nova rhythm usually starts on the third onset as follows: [1001001000100100]. However, other starting places are also documented in world music practices, such as [1001001001000100].",
  "E(6,7)" : "It is the Pontakos rhythm of Greece when started on the sixth (last) onset.",
  "E(6,13)" : "It is the rhythm of the dance Mama Cone pita from the FYROM. Started on the third onset, it is the rhythm of the dance Postupano Oro from the FYROM, as well as the Krivo Plovdivsko Horo of Bulgaria.",
  "E(7,8)" : "When started on the seventh (last) onset, is a typical rhythm played on the Bendir (frame drum), and used in the accompaniment of songs of the Tuareg people of Libya.",
  "E(7,9)" : "It is the Bazaragana rhythmic pattern of Greece.",
  "E(7,10)" : "It is the Lenk fahhte rhythmic pattern of Turkey.",
  "E(7,12)" : "It is a common West African bell pattern. For example, it is used in the Mpre rhythm of the Ashanti people of Ghana. Started on the seventh (last) onset, it is a Yoruba bell pattern of Nigeria, a Babenzele pattern of Central Africa, and a Mende pattern of Sierra Leone.",
  "E(7,15)" : "It is a Bulgarian rhythm when started on the third onset.",
  "E(7,16)" : "It is a Samba rhythm necklace from Brazil. The actual Samba rhythm is [1010010101001010] obtained by starting E(7, 16) on the last onset, and it coincides with a rhythm from the FYROM. When E(7, 16) is started on the fifth onset it is a clapping pattern from Ghana. When it is started on the second onset it is a rhythmic pattern found in the former Yugoslavia.",
  "E(7,17)" : "It is a rhythm from the FYROM when started on the second onset.",
  "E(7,18)" : "It is a Bulgarian rhythmic pattern.",
  "E(8,17)" : "It is a Bulgarian rhythmic pattern which is also started on the fifth onset.",
  "E(8,19)" : "It is a Bulgarian rhythmic pattern when started on the second onset.",
  "E(9,14)" : "When started on the second onset, it is the rhythmic pattern of the Tsofyan rhythm of Algeria.",
  "E(9,16)" : "It is a rhythm necklace used in the Central African Republic. When it is started on the second onset it is a bell pattern of the Luba people of Congo. When it is started on the fourth onset it is a rhythm played in West and Central Africa, as well as a cow-bell pattern in the Brazilian samba. When it is started on the penultimate onset it is the bell pattern of the Ngbaka-Maibo rhythms of the Central African Republic.",
  "E(9,22)" : "It is a Bulgarian rhythmic pattern when started on the second onset.",
  "E(9,23)" : "It is a Bulgarian rhythm.",
  "E(11,12)" : "When started on the second onset, is thedrum pattern of the Rahmani (a cylindrical double-headed drum) used in the Sot silam dance from Mirbat in the South of Oman.",
  "E(11,24)" : "It is a rhythm necklace of the Aka Pygmies of Central Africa. It is usually started on the seventh onset. Started on the second onset, it is a Bulgarian rhythm.",
  "E(13,24)" : "It is another rhythm necklace of the Aka Pygmies of the upper Sangha. Started on the penultimate onset, it is the Bobangi metal-blade pattern used by the Aka Pygmies.",
  "E(15,34)" : "It is a Bulgarian rhythmic pattern when started on the penultimate onset."
}

interval_names = {"unison": {"Harmonic": 1, "Cents": 0},
    "sixteenthtone": {"Harmonic": 129, "Cents": 13},
    "eighthtone": {"Harmonic": 65, "Cents": 27},
    "smaller quartertone": {"Harmonic": 131, "Cents": 40},
    "quartertone": {"Harmonic": 33, "Cents": 53},
    "large quartertone": {"Harmonic": 133, "Cents": 66},
    "small semitone / 3-eighthtones": {"Harmonic": 67, "Cents": 79},
    "minor semitone": {"Harmonic": 135, "Cents": 92},
    "Bb, major semitone": {"Harmonic": 17, "Cents": 105},
    "large semitone": {"Harmonic": 137, "Cents": 118},
    "big semitone": {"Harmonic": 69, "Cents": 130},
    "small three quarters of a tone": {"Harmonic": 139, "Cents": 143},
    "large three quarters of a tone": {"Harmonic": 35, "Cents": 155},
    "diminished whole tone": {"Harmonic": 141, "Cents": 167},
    "small whole tone": {"Harmonic": 71, "Cents": 180},
    "minor whole tone": {"Harmonic": 143, "Cents": 192},
    "B, major whole tone": {"Harmonic": 9, "Cents": 204},
    "large whole tone": {"Harmonic": 145, "Cents": 216},
    "whole plus eighthtone": {"Harmonic": 73, "Cents": 228},
    "5ET diesis": {"Harmonic": 147, "Cents": 240},
    "five quarters of a tone": {"Harmonic": 37, "Cents": 251},
    "diminished minor third": {"Harmonic": 149, "Cents": 263},
    "low minor third": {"Harmonic": 75, "Cents": 275},
    "small minor third": {"Harmonic": 151, "Cents": 286},
    "minor third": {"Harmonic": 19, "Cents": 298},
    "low just minor third (referencing 316)": {"Harmonic": 153, "Cents": 309},
    "high just minor third (referencing 316)": {"Harmonic": 77, "Cents": 320},
    "large minor third": {"Harmonic": 155, "Cents": 331},
    "big minor third": {"Harmonic": 39, "Cents": 342},
    "neutral third": {"Harmonic": 157, "Cents": 354},
    "tiny major third": {"Harmonic": 79, "Cents": 365},
    "eighthtone flat major third": {"Harmonic": 159, "Cents": 375},
    "C#, just major third": {"Harmonic": 5, "Cents": 386},
    "ET major third": {"Harmonic": 161, "Cents": 397},
    "Pythagorean ditone": {"Harmonic": 81, "Cents": 408},
    "large Pythagorean ditone": {"Harmonic": 21, "Cents": 418},
    "Db": {"Harmonic": 41, "Cents": 429},
    "small quartertone sharp major third": {"Harmonic": 163, "Cents": 440},
    "quartertone sharp major third": {"Harmonic": 83, "Cents": 450},
    "tiny fourth": {"Harmonic": 167, "Cents": 460},
    "low fourth": {"Harmonic": 21, "Cents": 471},
    "minor fourth": {"Harmonic": 169, "Cents": 481},
    "major fourth": {"Harmonic": 85, "Cents": 491},
    "ET perfect fourth": {"Harmonic": 171, "Cents": 501},
    "perfect fourth, D": {"Harmonic": 43, "Cents": 512},
    "fourth plus comma": {"Harmonic": 173, "Cents": 522},
    "fourth plus a fifthtone": {"Harmonic": 87, "Cents": 532},
    "fourth plus small quartertone": {"Harmonic": 175, "Cents": 541},
    "eleventh harmonic": {"Harmonic": 11, "Cents": 551},
    "tiny tritone": {"Harmonic": 177, "Cents": 561},
    "low tritone": {"Harmonic": 89, "Cents": 571},
    "minor tritone": {"Harmonic": 179, "Cents": 581},
    "D#": {"Harmonic": 45, "Cents": 590},
    "Eb, ET tritone": {"Harmonic": 181, "Cents": 600},
    "large tritone, Eb in tonal music": {"Harmonic": 91, "Cents": 609},
    "big tritone": {"Harmonic": 183, "Cents": 619},
    "eighthtone high tritone": {"Harmonic": 23, "Cents": 628},
    "quartertone and sixteenth flat dominant": {"Harmonic": 185, "Cents": 638},
    "quartertone flat dominant": {"Harmonic": 93, "Cents": 647},
    "tiny dominant": {"Harmonic": 187, "Cents": 656},
    "small dominant": {"Harmonic": 47, "Cents": 666},
    "eighthtone low dominant": {"Harmonic": 189, "Cents": 675},
    "irregular perfect fifth": {"Harmonic": 95, "Cents": 684},
    "sixth comma flat fifth": {"Harmonic": 191, "Cents": 693},
    "perfect fifth": {"Harmonic": 3, "Cents": 702},
    "poodle fifth": {"Harmonic": 193, "Cents": 711},
    "large fifth": {"Harmonic": 97, "Cents": 720},
    "howling dominant": {"Harmonic": 195, "Cents": 729},
    "sixthtone high dominant": {"Harmonic": 49, "Cents": 738},
    "three quartertones high perfect fifth": {"Harmonic": 197, "Cents": 746},
    "quartertone high perfect fifth": {"Harmonic": 99, "Cents": 755},
    "quartertone and 16th tone high fifth": {"Harmonic": 199, "Cents": 764},
    "quartertone and eighthtone high fifth": {"Harmonic": 25, "Cents": 773},
    "almost minor sixth": {"Harmonic": 201, "Cents": 781},
    "tiny minor sixth": {"Harmonic": 101, "Cents": 790},
    "ET minor sixth": {"Harmonic": 203, "Cents": 798},
    "minor sixth": {"Harmonic": 22, "Cents": 807},
    "just minor sixth": {"Harmonic": 205, "Cents": 815},
    "large minor sixth": {"Harmonic": 103, "Cents": 824},
    "big minor sixth": {"Harmonic": 207, "Cents": 832},
    "thirteenth harmonic": {"Harmonic": 13, "Cents": 841},
    "quartertone high minor sixth": {"Harmonic": 209, "Cents": 849},
    "quartertone plus minor sixth": {"Harmonic": 105, "Cents": 857},
    "almost major sixth": {"Harmonic": 211, "Cents": 865},
    "tiny major sixth": {"Harmonic": 53, "Cents": 874},
    "small major sixth": {"Harmonic": 213, "Cents": 882},
    "just major sixth": {"Harmonic": 107, "Cents": 890},
    "ET major sixth": {"Harmonic": 215, "Cents": 898},
    "major sixth": {"Harmonic": 27, "Cents": 906},
    "sixthtone high major sixth": {"Harmonic": 217, "Cents": 914},
    "eighthtone high major sixth": {"Harmonic": 109, "Cents": 922},
    "eighthtone and 16th tone high major sixth": {"Harmonic": 219, "Cents": 930},
    "large major sixth": {"Harmonic": 55, "Cents": 938},
    "big major sixth": {"Harmonic": 221, "Cents": 945},
    "three quartertone sharp major sixth": {"Harmonic": 111, "Cents": 953},
    "small harmonic seventh": {"Harmonic": 223, "Cents": 961},
    "harmonic seventh": {"Harmonic": 7, "Cents": 969},
    "large harmonic seventh": {"Harmonic": 225, "Cents": 977},
    "tiny minor seventh": {"Harmonic": 113, "Cents": 984},
    "small minor seventh": {"Harmonic": 227, "Cents": 992},
    "G, minor seventh": {"Harmonic": 57, "Cents": 999},
    "large minor seventh": {"Harmonic": 229, "Cents": 1007},
    "big minor seventh": {"Harmonic": 115, "Cents": 1015},
    "double perfect fourth": {"Harmonic": 231, "Cents": 1022},
    "eighthtone high major seventh": {"Harmonic": 29, "Cents": 1030},
    "eighth- and 16th tone high minor seventh": {"Harmonic": 233, "Cents": 1037},
    "three-eighths flat major seventh": {"Harmonic": 117, "Cents": 1044},
    "quartertone flat minor seventh": {"Harmonic": 235, "Cents": 1052},
    "tiny major seventh": {"Harmonic": 59, "Cents": 1059},
    "diminished major seventh": {"Harmonic": 237, "Cents": 1066},
    "eighthtone flat major seventh": {"Harmonic": 119, "Cents": 1074},
    "small major seventh": {"Harmonic": 239, "Cents": 1081},
    "major seventh": {"Harmonic": 15, "Cents": 1088},
    "large major seventh": {"Harmonic": 241, "Cents": 1095},
    "ET major seventh": {"Harmonic": 121, "Cents": 1103},
    "big major seventh": {"Harmonic": 243, "Cents": 1110},
    "Ab, large minor seventh": {"Harmonic": 61, "Cents": 1117},
    "eighthtone plus major seventh": {"Harmonic": 245, "Cents": 1124},
    "leading tone major seventh": {"Harmonic": 123, "Cents": 1131},
    "sharp leading tone major seventh": {"Harmonic": 247, "Cents": 1138},
    "hyper leading tone major seventh": {"Harmonic": 31, "Cents": 1145},
    "quartertone flat octave": {"Harmonic": 249, "Cents": 1152},
    "three-eighths flat octave": {"Harmonic": 125, "Cents": 1159},
    "eighthtone flat octave": {"Harmonic": 251, "Cents": 1166},
    "small octave": {"Harmonic": 63, "Cents": 1173},
    "comma flat octave": {"Harmonic": 253, "Cents": 1180},
    "dipped octave": {"Harmonic": 127, "Cents": 1186},
    "preoctave": {"Harmonic": 255, "Cents": 1193}
}

chord_frequencies = {
    'C': [261.63, 329.63, 392.00],   # C major
    'Em': [329.63, 392.00, 493.88],  # E minor
    'F': [349.23, 440.00, 523.25],   # F major
    'Bdim': [466.16, 554.37, 659.25],# B diminished
    'G7': [392.00, 493.88, 587.33, 698.46],  # G dominant 7th
    'Am': [440.00, 523.25, 659.25],  # A minor
    'D7': [293.66, 349.23, 440.00, 587.33],  # D dominant 7th
    'Dm': [293.66, 349.23, 440.00],  # D minor
    'E7': [329.63, 415.30, 493.88, 659.25],  # E dominant 7th
    'A7': [440.00, 523.25, 587.33, 659.25],  # A dominant 7th
    'Cmaj7': [261.63, 329.63, 392.00, 493.88], # C major 7th
    'Em7': [329.63, 392.00, 493.88, 587.33],   # E minor 7th
    'Dm7b5': [293.66, 349.23, 415.30, 493.88], # D minor 7th flat 5
    'C7': [261.63, 329.63, 392.00, 466.16],    # C dominant 7th
    'G': [392.00, 493.88, 587.33],  # G major
    'III7': [349.23, 440.00, 523.25, 622.25],  # E7 in the context of C major
    'VI7': [415.30, 523.25, 622.25, 698.46],   # A7 in the context of C major
    'II7': [293.66, 369.99, 440.00, 523.25],   # D7 in the context of C major
    'C/E': [329.63, 392.00, 523.25],  # C major first inversion (E, G, C)
    'V7/V': [293.66, 349.23, 415.30, 493.88],  # D7 as secondary dominant to G (D, F#, A, C)
    'F7': [349.23, 440.00, 523.25, 622.25],  # F dominant 7th (F, A, C, Eb)
    'A7': [440.00, 523.25, 587.33, 659.25],  # A dominant 7th (A, C#, E, G)
    'Db7': [277.18, 369.99, 466.16, 554.37], 
    'Dm7': [293.66, 349.23, 440.00, 523.25],
    'Fmaj7': [349.23, 440.00, 523.25, 659.25],
    'Bb7': [233.08, 311.13, 392.00, 466.16],

}

interval_catalog = [
    ("Unison" , sp.Integer(1)),
    ("Ragisma" , sp.Rational(4375, 4374)),
    ("Breedsma", sp.Rational(2401, 2400)),
    ("Cent", sp.Integer(2) ** sp.Rational(1,1200)),
    ("Millioctave", sp.Integer(2) ** sp.Rational(1,1000)),
    ("Schisma", sp.Rational(32805, 32768)),
    ("Savart",  sp.Integer(10) ** sp.Rational(1,1000)),
    ("Septimal Kleisma", sp.Rational(225, 224)),
    ("Kleisma", sp.Rational(15625, 15552)),
    ("Semicomma", sp.Rational(2109375, 2097152)),
    ("Sixteenth Tone",  sp.Integer(2) ** sp.Rational(1,96)),
    ("Orwell Comma", sp.Rational(1728, 1715)),
    ("Hundred-twenty-ninth Harmonic", sp.Rational(129, 128)),
    ("Small Septimal Semicomma", sp.Rational(126, 125)),
    ("Unidecimal Seconds Comma", sp.Rational(121, 120)),
    ("Diaschisma", sp.Rational(2048, 2025)),
    ("Syntonic Comma", sp.Rational(81, 80)),
    ("Holdrian Comma",  sp.Integer(2) ** sp.Rational(1,53)),
    ("Pythagorean Comma", sp.Rational(531441, 524288)),
    ("Eighth Tone",  sp.Integer(2) ** sp.Rational(1,48)),
    ("Sixty-fifth Harmonic", sp.Rational(65, 64)),
    ("Septimal Comma", sp.Rational(64, 63)),
    ("Ptolemy's Enharmonic", sp.Rational(56, 55)),
    ("Sixth Tone",  sp.Integer(2) ** sp.Rational(1,36)),
    ("Septimal Sixth Tone",  sp.Rational(50, 49)),
    ("Inferior Quarter Tone",  sp.Rational(46, 45)),
    ("Undecimal Diesis",  sp.Rational(45, 44)),
    ("Fifth Tone",  sp.Integer(2) ** sp.Rational(1,30)),
    ("Enharmonic Diesis",  sp.Rational(128, 125)),
    ("Lesser 41-limit Fifth Tone",  sp.Rational(42, 41)),
    ("Greater 41-limit Fifth Tone",  sp.Rational(41, 40)),
    ("Septimal Quarter Tone",  sp.Rational(36, 35)),
    ("Just Quarter Tone",  sp.Rational(246, 239)),
    ("Equal-tempered Quarter Tone",  sp.Integer(2) ** sp.Rational(1,24)),
    ("Lesser 17-limit Quarter Tone",  sp.Rational(35, 34)),
    ("Harrison's Comma",  sp.Rational(59049, 57344)),
    ("Greater 17-limit Quarter Tone",  sp.Rational(34, 33)),
    ("Thrty-third Harmonic",  sp.Rational(33, 32)),
    ("Inferior Quarter Tone",  sp.Rational(32, 31)),
    ("Five-hundred-twenty-ninth harmonic",  sp.Rational(529, 512)),
    ("Greater Quarter Tone",  sp.Rational(31, 30)),
    ("Lesser 29-limit Quarter Tone",  sp.Rational(30, 29)),
    ("Greater 29-limit Quarter Tone",  sp.Rational(29, 28)),
    ("Septimal Minor Second",  sp.Rational(28, 27)),
    ("Beta Scale Step",  sp.Rational(3, 2) ** sp.Rational(1, 11)),
    ("Chromatic Diesis",  sp.Rational(27, 26)),
    ("One-hundred-thirty-third Harmonic",  sp.Rational(133, 128)),
    ("Third Tone",  sp.Integer(2) ** sp.Rational(1,18)),
    ("Tridecimal Third Tone",  sp.Rational(26, 25)),
    ("Just Chromatic Semitone",  sp.Rational(25, 24)),
    ("Lesser 23-limit Semitone",  sp.Rational(24, 23)),
    ("Greater 23-limit Semitone",  sp.Rational(23, 22)),
    ("Alpha Scale Step",  sp.Rational(3, 2) ** sp.Rational(1, 9)),
    ("Sixty-seventh Harmonic",  sp.Rational(67, 64)),
    ("Hard Semitone",  sp.Rational(22, 21)),
    ("Septimal Chromatic Semitone",  sp.Rational(21, 20)),
    ("Novendecimal Augmented Unison",  sp.Rational(20, 19)),
    ("Pythagorean Minor Second",  sp.Rational(256, 243)),
    ("Greater Chromatic Semitone",  sp.Rational(135, 128)),
    ("Novendecimal Minor Second",  sp.Rational(19, 18)),
    ("121st Subharmonic",  sp.Rational(128, 121)),
    ("Just Minor Semitone",  sp.Rational(18, 17)),
    ("Equal-tempered Minor Second",  sp.Integer(2) ** sp.Rational(1,12)),
    ("Minor Diatonic Semitone",  sp.Rational(17, 16)),
    ("Just Minor Second",  sp.Rational(16, 15)),
    ("Pythagorean Major Semitone",  sp.Rational(2187, 2048)),
    ("Secor",  sp.Rational(18, 5) ** sp.Rational(1, 19)),
    ("Septimal Diatonic Semitone",  sp.Rational(15, 14)),
    ("Lesser Tridecimal 2/3-tone",  sp.Rational(14, 13)),
    ("Sixty-ninth Harmonic",  sp.Rational(69, 64)),
    ("Semitone maximus",  sp.Rational(27, 25)),
    ("Two-third Tone",  sp.Integer(2) ** sp.Rational(1,19)),
    ("Greater Tridecimal 2/3-tone",  sp.Rational(13, 12)),
    ("Equal-tempered Neutral Second",  sp.Integer(2) ** sp.Rational(3,24)),
    ("3/4-tone",  sp.Rational(12,11)),
    ("Thirty-fifth Harmonic",  sp.Rational(35, 32)),
    ("Grave Whole Tone",  sp.Rational(800, 729)),
    ("Ptolemy's second",  sp.Rational(11, 10)),
    ("Seventy-first Harmonic",  sp.Rational(71, 64)),
    ("Pythagorean Diminished Third",  sp.Rational(65536, 9049)),
    ("Small Just Whole Tone",  sp.Rational(10, 9)),
    ("Equal-tempered Major Second",  sp.Integer(2) ** sp.Rational(2,12)),
    ("Pythagorean Major Second",  sp.Rational(9, 8)),
    ("Hundred-forty-fifth Harmonic",  sp.Rational(145, 128)),
    ("Just Diminished Third",  sp.Rational(256, 225)),
    ("Seventy-third Harmonic",  sp.Rational(73, 64)),
    ("Septimal Major Second",  sp.Rational(8, 7)),
    ("Thirty-seventh Harmonic",  sp.Rational(37, 32)),
    ("Semi-augmented Whole Tone",  sp.Rational(125, 108)),
    ("55th Subharmonic",  sp.Rational(64, 55)),
    ("Two-hundred-ninety-ninth Harmonic",  sp.Rational(299, 256)),
    ("Septimal Minor Third",  sp.Rational(7, 6)),
    ("Just Augmented Second",  sp.Rational(75, 64)),
    ("Pythagorean Minor Third",  sp.Rational(32, 27)),
    ("19th Harmonic",  sp.Rational(19, 16)),
    ("Equal-tempered Minor Third",  sp.Integer(2) ** sp.Rational(3,12)),
    ("Quasi-equal-tempered Minor Third",  sp.Rational(25, 21)),
    ("Quarter-comma Meantone Minor Third",  sp.Rational(8,5)/(sp.Rational(81, 80)**sp.Rational(1,4))),
    ("Alpha Scale Minor Third",  sp.Rational(3, 2) ** sp.Rational(4, 9)),
    ("Just Minor Third",  sp.Rational(6, 5)),
    ("Pythagorean Augmented Second",  sp.Rational(19683, 16384)),
    ("Seventy-seventh Harmonic",  sp.Rational(77, 64)),
    ("Superminor Third",  sp.Rational(17, 14)),
    ("Acute Minor Third",  sp.Rational(243, 200)),
    ("Thirty-ninth Harmonic",  sp.Rational(39, 32)),
    ("105th Subharmonic",  sp.Rational(128, 105)),
    ("Undecimal Neutral Third",  sp.Rational(11, 9)),
    ("Equal-tempered Neutral Third",  sp.Integer(2) ** sp.Rational(7, 24)),
    ("Zalzal's Wosta",  sp.Rational(27, 22)),
    ("Tridecimal Neutral Third",  sp.Rational(16, 13)),
    ("Seventy-ninth Harmonic",  sp.Rational(79, 64)),
    ("Grave Major Third",  sp.Rational(100, 81)),
    ("Pythagorean Diminished Fourth",  sp.Rational(8192, 6561)),
    ("Just Major Third",  sp.Rational(5, 4)),
    ("One-hundred-sixty-first Harmonic",  sp.Rational(161, 128)),
    ("Equal-tempered Major Third",  sp.Integer(2) ** sp.Rational(4, 12)),
    ("Three-hundred-twenty-third Harmonic",  sp.Rational(323, 256)),
    ("Pythagorean Major Third",  sp.Rational(81, 64)),
    ("Undecimal Diminished Fourth",  sp.Rational(14, 11)),
    ("Just Diminished Fourth",  sp.Rational(32, 25)),
    ("Forty-first Harmonic",  sp.Rational(41, 32)),
    ("Septimal Major Third",  sp.Rational(9, 7)),
    ("99th Subharmonic",  sp.Rational(128, 99)),
    ("Eighty-third Harmonic",  sp.Rational(83, 64)),
    ("Tridecimal Major Third ",  sp.Rational(13, 10)),
    ("Just Augmented Third ",  sp.Rational(125, 96)),
    ("49th Subharmonic",  sp.Rational(64, 49)),
    ("21st Harmonic",  sp.Rational(21, 16)),
    ("Wide Augmented Third",  sp.Rational(675, 512)),
    ("85th Harmonic",  sp.Rational(85, 64)),
    ("Perfect Fourth",  sp.Rational(4, 3)),
    ("Equal-tempered Perfect Fourth",  sp.Integer(2) ** sp.Rational(5, 12)),
    ("One-hundred-seventy-first Harmonic",  sp.Rational(171, 128)),
    ("Beta Scale Perfect Fourth",  sp.Rational(3, 2) ** sp.Rational(8, 11)),
    ("Forty-third Harmonic",  sp.Rational(43, 32)),
    ("5-limit Wolf Fourth",  sp.Rational(27, 20)),
    ("Pythagorean Augmented Third",  sp.Rational(177147, 131072)),
    ("Eighty-seventh Harmonic",  sp.Rational(87, 64)),
    ("Eleventh Harmonic",  sp.Rational(11, 8)),
    ("Just Augmented Fourth",  sp.Rational(25, 18)),
    ("Eighty-ninth Harmonic",  sp.Rational(89, 64)),
    ("Lesser Septimal Tritone",  sp.Rational(7, 5)),
    ("Pythagorean Diminished Fifth",  sp.Rational(1024, 729)),
    ("Just Augmented Fourth",  sp.Rational(45, 32)),
    ("Three-hundred-sixty-first Harmonic",  sp.Rational(361, 256)),
    ("Equal-tempered Tritone",  sp.Integer(2) ** sp.Rational(6, 12)),
    ("Ninety-first Harmonic",  sp.Rational(91, 64)),
    ("Just Tritone",  sp.Rational(64, 45)),
    ("Pythagorean Tritone",  sp.Rational(729, 512)),
    ("Greater Septimal Tritone",  sp.Rational(10, 7)),
    ("Twenty-third Harmonic",  sp.Rational(23, 16)),
    ("Just Diminished Fifth",  sp.Rational(36, 25)),
    ("Ninety-third Harmonic",  sp.Rational(93, 64)),
    ("Undecimal Semi-diminished Fifth",  sp.Rational(16, 11)),
    ("Forty-seventh Harmonic",  sp.Rational(47, 32)),
    ("Pythagorean Diminished Sixth",  sp.Rational(262144, 177147)),
    ("5-limit Wolf Fifth",  sp.Rational(40, 27)),
    ("Ninety-fifth Harmonic",  sp.Rational(95, 64)),
    ("12167th Harmonic",  sp.Rational(12167, 8192)),
    ("Half-comma Meantone Perfect Fifth",  sp.Rational(3,2)/(sp.Rational(81, 80)**sp.Rational(1,2))),
    ("1/3-comma Meantone Perfect Fifth",  sp.Rational(3,2)/(sp.Rational(81, 80)**sp.Rational(1,3))),
    ("2/7-comma Meantone Perfect Fifth",  sp.Rational(3,2)/(sp.Rational(81, 80)**sp.Rational(2,7))),
    ("Quarter-comma Meantone Perfect Fifth",  sp.Rational(3,2)/(sp.Rational(81, 80)**sp.Rational(1,4))),
    ("1/5-comma Meantone Perfect Fifth",  sp.Rational(3,2)/(sp.Rational(81, 80)**sp.Rational(1,5))),
    ("1/6-comma Meantone Perfect Fifth",  sp.Rational(3,2)/(sp.Rational(81, 80)**sp.Rational(1,6))),
    ("Equal-tempered Perect Fifth",  sp.Integer(2) ** sp.Rational(7, 12)),
    ("53-TET Perect Fifth",  sp.Integer(2) ** sp.Rational(31, 53)),
    ("Perfect Fifth",  sp.Rational(3, 2)),
    ("41-TET Perect Fifth",  sp.Integer(2) ** sp.Rational(24, 41)),
    ("29-TET Perect Fifth",  sp.Integer(2) ** sp.Rational(17, 29)),
    ("Ninety-seventh Harmonic",  sp.Rational(97, 64)),
    ("Narrow Diminished Sixth",  sp.Rational(1024, 675)),
    ("21st Subharmonic",  sp.Rational(32, 21)),
    ("Three-hundred-ninety-first Harmonic",  sp.Rational(391, 256)),
    ("Forty-ninth Harmonic",  sp.Rational(49, 32)),
    ("Classic Diminished Sixth",  sp.Rational(192, 125)),
    ("Ninety-ninth Harmonic",  sp.Rational(99, 64)),
    ("Septimal Minor Sixth",  sp.Rational(14, 9)),
    ("Just Augmented Fifth",  sp.Rational(25, 16)),
    ("Wallis Product",  sp.pi / sp.Integer(2)),
    ("Undecimal Minor Sixth",  sp.Rational(11, 7)),
    ("Hundred-first Harmonic",  sp.Rational(101, 64)),
    ("Pythagorean Minor Sixth",  sp.Rational(128, 81)),
    ("Two-hundred-third Harmonic",  sp.Rational(203, 128)),
    ("Equal-tempered Minor Sixth",  sp.Integer(2) ** sp.Rational(8, 12)),
    ("Fifty-first Harmonic",  sp.Rational(51, 32)),
    ("Just Minor Sixth",  sp.Rational(8, 5)),
    ("Pythagorean Augmented Fifth",  sp.Rational(6561, 4096)),
    ("Hundred-third Harmonic",  sp.Rational(103, 64)),
    ("Two-hundred-seventh Harmonic",  sp.Rational(207, 128)),
    ("Golden Ratio", sp.Integer(5) ** sp.Rational(1,2) +  sp.Rational(1, 2)),
    ("Golden Ratio Approximation", sp.Rational(233, 144)),
    ("Acute Minor Sixth", sp.Rational(81, 50)),
    ("Tridecimal Neutral Sixth", sp.Rational(13, 8)),
    ("Two-hundred-ninth Harmonic",  sp.Rational(209, 128)),
    ("Equal-tempered Neutral Sixth",  sp.Integer(2) ** sp.Rational(17, 24)),
    ("Undecimal Neutral Sixth",  sp.Integer(2) ** sp.Rational(18, 11)),
    ("Hundred-fifth Harmonic",  sp.Rational(105, 64)),
    ("Grave Major Sixth",  sp.Rational(400, 243)),
    ("Fifty-third Harmonic",  sp.Rational(53, 32)),
    ("Seventy-seventh Subharmonic",  sp.Rational(128, 77)),
    ("Pythagorean Diminished Seventh",  sp.Rational(32768, 19683)),
    ("Just Major Sixth",  sp.Rational(5, 3)),
    ("Hundred-seventh Harmonic",  sp.Rational(107, 64)),
    ("6859th Harmonic",  sp.Rational(6859, 4096)),
    ("Equal-tempered Major Sixth",  sp.Integer(2) ** sp.Rational(9, 12)),
    ("19th Subharmonic",  sp.Rational(32, 19)),
    ("Pythagorean Major Sixth",  sp.Rational(27, 16)),
    ("Hundred-ninth Harmonic",  sp.Rational(109, 64)),
    ("Just Diminished Seventh",  sp.Rational(128, 75)),
    ("Four-hundred-thirty-seventh Harmonic",  sp.Rational(437, 256)),
    ("Septimal major sixth",  sp.Rational(12, 7)),
    ("Fifty-fifth Harmonic",  sp.Rational(55, 32)),
    ("Hundred-eleventh Harmonic",  sp.Rational(111, 64)),
    ("Just Augmented Sixth",  sp.Rational(125, 72)),
    ("Septimal Minor Seventh",  sp.Rational(7, 4)),
    ("Just Augmented Sixth II",  sp.Rational(225, 128)),
    ("Hundred-thirteenth Harmonic",  sp.Rational(113, 64)),
    ("Pythagorean Minor Seventh",  sp.Rational(16, 9)),
    ("Fifty-seventh Harmonic",  sp.Rational(57, 32)),
    ("Equal-tempered Minor Seventh",  sp.Integer(2) ** sp.Rational(10, 12)),
    ("Hundred-fifteenth Harmonic",  sp.Rational(115, 64)),
    ("Greater Just Minor Seventh",  sp.Rational(9, 5)),
    ("Pythagorean Augmented Sixth",  sp.Rational(59049, 32768)),
    ("Twenty-ninth Harmonic",  sp.Rational(29, 16)),
    ("Lesser Undecimal Neutral Seventh",  sp.Rational(20, 11)),
    ("Acute Minor Seventh", sp.Rational(729, 400)),
    ("Hundred-seventeenth Harmonic",  sp.Rational(117, 64)),
    ("35th Subharmonic",  sp.Rational(64, 35)),
    ("Undecimal Neutral Seventh",  sp.Rational(11, 6)),
    ("Equal-tempered Neutral Seventh",  sp.Integer(2) ** sp.Rational(21, 24)),
    ("Fifty-ninth Harmonic",  sp.Rational(59, 32)),
    ("Grave Major Seventh",  sp.Rational(50, 27)),
    ("Hundred-nineteenth Harmonic",  sp.Rational(119, 64)),
    ("Pythagorean Diminished Octave",  sp.Rational(4096, 2187)),
    ("Just Major Seventh",  sp.Rational(15, 8)),
    ("17th Subharmonic",  sp.Rational(32, 17)),
    ("Equal-tempered Major Seventh",  sp.Integer(2) ** sp.Rational(11, 12)),
    ("Hundred-twenty-first Harmonic",  sp.Rational(121, 64)),
    ("Narrow Diminished Octave",  sp.Rational(256, 135)),
    ("Pythagorean Major Seventh",  sp.Rational(243, 128)),
    ("Sixty-first Harmonic",  sp.Rational(61, 32)),
    ("Classic Diminished Octave",  sp.Rational(48, 25)),
    ("Hundred-twenty-third Harmonic",  sp.Rational(123, 64)),
    ("Septimal Major Seventh",  sp.Rational(27, 14)),
    ("Two-hundred-forty-seventh Harmonic",  sp.Rational(247, 128)),
    ("Thirty-first Harmonic",  sp.Rational(31, 16)),
    ("Thirty-third Subharmonic",  sp.Rational(64, 33)),
    ("Septimal Supermajor Seventh",  sp.Rational(35, 18)),
    ("Just Augmented Seventh",  sp.Rational(125, 64)),
    ("Sixty-third Harmonic",  sp.Rational(63, 32)),
    ("Semi-diminished Octave",  sp.Rational(160, 81)),
    ("Two-hundred-fifty-third Harmonic",  sp.Rational(253, 128)),
    ("Hundred-twenty-seventh Harmonic",  sp.Rational(127, 64)),
    ("Octave",  sp.Rational(2, 1)),
    ("Pythagorean Augmented Seventh",  sp.Rational(531441, 262144)),
    ("Silver Ratio",  sp.Integer(2) ** sp.Rational(1, 2) + sp.Integer(1)),
    ("Just Perfect Twelfth",  sp.Rational(3, 1)),
    ("Fifteenth",  sp.Rational(4, 1)),
    ("Decade",  sp.Rational(10, 1)),
]